/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface. The Ed-Fi ODS / API supports both transactional and bulk modes of operation.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiBellSchedule
    /// </summary>
    [DataContract]
    public partial class EdFiBellSchedule :  IEquatable<EdFiBellSchedule>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiBellSchedule" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiBellSchedule() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiBellSchedule" /> class.
        /// </summary>
        /// <param name="Id">Id (required).</param>
        /// <param name="BellScheduleName">Name or title of the BellSchedule. (required).</param>
        /// <param name="ClassPeriods">An unordered collection of bellScheduleClassPeriods. The class periods that compose this BellSchedule. (required).</param>
        /// <param name="SchoolReference">SchoolReference (required).</param>
        /// <param name="AlternateDayName">An alternate name for the day (e.g., Red, Blue)..</param>
        /// <param name="Dates">An unordered collection of bellScheduleDates. The dates for which the BellSchedule applies..</param>
        /// <param name="GradeLevels">An unordered collection of bellScheduleGradeLevels. The grade levels the particular BellSchedule applies to..</param>
        /// <param name="Etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiBellSchedule(string Id = default(string), string BellScheduleName = default(string), List<EdFiBellScheduleClassPeriod> ClassPeriods = default(List<EdFiBellScheduleClassPeriod>), EdFiSchoolReference SchoolReference = default(EdFiSchoolReference), string AlternateDayName = default(string), List<EdFiBellScheduleDate> Dates = default(List<EdFiBellScheduleDate>), List<EdFiBellScheduleGradeLevel> GradeLevels = default(List<EdFiBellScheduleGradeLevel>), string Etag = default(string))
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for EdFiBellSchedule and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "BellScheduleName" is required (not null)
            if (BellScheduleName == null)
            {
                throw new InvalidDataException("BellScheduleName is a required property for EdFiBellSchedule and cannot be null");
            }
            else
            {
                this.BellScheduleName = BellScheduleName;
            }
            // to ensure "ClassPeriods" is required (not null)
            if (ClassPeriods == null)
            {
                throw new InvalidDataException("ClassPeriods is a required property for EdFiBellSchedule and cannot be null");
            }
            else
            {
                this.ClassPeriods = ClassPeriods;
            }
            // to ensure "SchoolReference" is required (not null)
            if (SchoolReference == null)
            {
                throw new InvalidDataException("SchoolReference is a required property for EdFiBellSchedule and cannot be null");
            }
            else
            {
                this.SchoolReference = SchoolReference;
            }
            this.AlternateDayName = AlternateDayName;
            this.Dates = Dates;
            this.GradeLevels = GradeLevels;
            this.Etag = Etag;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Name or title of the BellSchedule.
        /// </summary>
        /// <value>Name or title of the BellSchedule.</value>
        [DataMember(Name="bellScheduleName", EmitDefaultValue=false)]
        public string BellScheduleName { get; set; }

        /// <summary>
        /// An unordered collection of bellScheduleClassPeriods. The class periods that compose this BellSchedule.
        /// </summary>
        /// <value>An unordered collection of bellScheduleClassPeriods. The class periods that compose this BellSchedule.</value>
        [DataMember(Name="classPeriods", EmitDefaultValue=false)]
        public List<EdFiBellScheduleClassPeriod> ClassPeriods { get; set; }

        /// <summary>
        /// Gets or Sets SchoolReference
        /// </summary>
        [DataMember(Name="schoolReference", EmitDefaultValue=false)]
        public EdFiSchoolReference SchoolReference { get; set; }

        /// <summary>
        /// An alternate name for the day (e.g., Red, Blue).
        /// </summary>
        /// <value>An alternate name for the day (e.g., Red, Blue).</value>
        [DataMember(Name="alternateDayName", EmitDefaultValue=false)]
        public string AlternateDayName { get; set; }

        /// <summary>
        /// An unordered collection of bellScheduleDates. The dates for which the BellSchedule applies.
        /// </summary>
        /// <value>An unordered collection of bellScheduleDates. The dates for which the BellSchedule applies.</value>
        [DataMember(Name="dates", EmitDefaultValue=false)]
        public List<EdFiBellScheduleDate> Dates { get; set; }

        /// <summary>
        /// An unordered collection of bellScheduleGradeLevels. The grade levels the particular BellSchedule applies to.
        /// </summary>
        /// <value>An unordered collection of bellScheduleGradeLevels. The grade levels the particular BellSchedule applies to.</value>
        [DataMember(Name="gradeLevels", EmitDefaultValue=false)]
        public List<EdFiBellScheduleGradeLevel> GradeLevels { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name="_etag", EmitDefaultValue=false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiBellSchedule {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  BellScheduleName: ").Append(BellScheduleName).Append("\n");
            sb.Append("  ClassPeriods: ").Append(ClassPeriods).Append("\n");
            sb.Append("  SchoolReference: ").Append(SchoolReference).Append("\n");
            sb.Append("  AlternateDayName: ").Append(AlternateDayName).Append("\n");
            sb.Append("  Dates: ").Append(Dates).Append("\n");
            sb.Append("  GradeLevels: ").Append(GradeLevels).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiBellSchedule);
        }

        /// <summary>
        /// Returns true if EdFiBellSchedule instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiBellSchedule to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiBellSchedule input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.BellScheduleName == input.BellScheduleName ||
                    (this.BellScheduleName != null &&
                    this.BellScheduleName.Equals(input.BellScheduleName))
                ) && 
                (
                    this.ClassPeriods == input.ClassPeriods ||
                    this.ClassPeriods != null &&
                    this.ClassPeriods.SequenceEqual(input.ClassPeriods)
                ) && 
                (
                    this.SchoolReference == input.SchoolReference ||
                    (this.SchoolReference != null &&
                    this.SchoolReference.Equals(input.SchoolReference))
                ) && 
                (
                    this.AlternateDayName == input.AlternateDayName ||
                    (this.AlternateDayName != null &&
                    this.AlternateDayName.Equals(input.AlternateDayName))
                ) && 
                (
                    this.Dates == input.Dates ||
                    this.Dates != null &&
                    this.Dates.SequenceEqual(input.Dates)
                ) && 
                (
                    this.GradeLevels == input.GradeLevels ||
                    this.GradeLevels != null &&
                    this.GradeLevels.SequenceEqual(input.GradeLevels)
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.BellScheduleName != null)
                    hashCode = hashCode * 59 + this.BellScheduleName.GetHashCode();
                if (this.ClassPeriods != null)
                    hashCode = hashCode * 59 + this.ClassPeriods.GetHashCode();
                if (this.SchoolReference != null)
                    hashCode = hashCode * 59 + this.SchoolReference.GetHashCode();
                if (this.AlternateDayName != null)
                    hashCode = hashCode * 59 + this.AlternateDayName.GetHashCode();
                if (this.Dates != null)
                    hashCode = hashCode * 59 + this.Dates.GetHashCode();
                if (this.GradeLevels != null)
                    hashCode = hashCode * 59 + this.GradeLevels.GetHashCode();
                if (this.Etag != null)
                    hashCode = hashCode * 59 + this.Etag.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // BellScheduleName (string) maxLength
            if(this.BellScheduleName != null && this.BellScheduleName.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for BellScheduleName, length must be less than 60.", new [] { "BellScheduleName" });
            }

            // AlternateDayName (string) maxLength
            if(this.AlternateDayName != null && this.AlternateDayName.Length > 20)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AlternateDayName, length must be less than 20.", new [] { "AlternateDayName" });
            }

            yield break;
        }
    }

}
