/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface. The Ed-Fi ODS / API supports both transactional and bulk modes of operation.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStaffCredential
    /// </summary>
    [DataContract]
    public partial class EdFiStaffCredential :  IEquatable<EdFiStaffCredential>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStaffCredential" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStaffCredential() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStaffCredential" /> class.
        /// </summary>
        /// <param name="CredentialReference">CredentialReference (required).</param>
        public EdFiStaffCredential(EdFiCredentialReference CredentialReference = default(EdFiCredentialReference))
        {
            // to ensure "CredentialReference" is required (not null)
            if (CredentialReference == null)
            {
                throw new InvalidDataException("CredentialReference is a required property for EdFiStaffCredential and cannot be null");
            }
            else
            {
                this.CredentialReference = CredentialReference;
            }
        }
        
        /// <summary>
        /// Gets or Sets CredentialReference
        /// </summary>
        [DataMember(Name="credentialReference", EmitDefaultValue=false)]
        public EdFiCredentialReference CredentialReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStaffCredential {\n");
            sb.Append("  CredentialReference: ").Append(CredentialReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStaffCredential);
        }

        /// <summary>
        /// Returns true if EdFiStaffCredential instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStaffCredential to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStaffCredential input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CredentialReference == input.CredentialReference ||
                    (this.CredentialReference != null &&
                    this.CredentialReference.Equals(input.CredentialReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CredentialReference != null)
                    hashCode = hashCode * 59 + this.CredentialReference.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
