/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface. The Ed-Fi ODS / API supports both transactional and bulk modes of operation.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStudentCompetencyObjective
    /// </summary>
    [DataContract]
    public partial class EdFiStudentCompetencyObjective :  IEquatable<EdFiStudentCompetencyObjective>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentCompetencyObjective" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStudentCompetencyObjective() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentCompetencyObjective" /> class.
        /// </summary>
        /// <param name="Id">Id (required).</param>
        /// <param name="GradingPeriodReference">GradingPeriodReference (required).</param>
        /// <param name="ObjectiveCompetencyObjectiveReference">ObjectiveCompetencyObjectiveReference (required).</param>
        /// <param name="StudentReference">StudentReference (required).</param>
        /// <param name="CompetencyLevelDescriptor">The CompetencyLevel assessed for the student for the referenced LearningObjective. (required).</param>
        /// <param name="DiagnosticStatement">A statement provided by the teacher that provides information in addition to the grade or assessment score..</param>
        /// <param name="GeneralStudentProgramAssociations">An unordered collection of studentCompetencyObjectiveGeneralStudentProgramAssociations. Relates the Student and Program associated with the CompetencyObjective..</param>
        /// <param name="StudentSectionAssociations">An unordered collection of studentCompetencyObjectiveStudentSectionAssociations. Relates the Student and Section associated with the CompetencyObjective..</param>
        /// <param name="Etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiStudentCompetencyObjective(string Id = default(string), EdFiGradingPeriodReference GradingPeriodReference = default(EdFiGradingPeriodReference), EdFiCompetencyObjectiveReference ObjectiveCompetencyObjectiveReference = default(EdFiCompetencyObjectiveReference), EdFiStudentReference StudentReference = default(EdFiStudentReference), string CompetencyLevelDescriptor = default(string), string DiagnosticStatement = default(string), List<EdFiStudentCompetencyObjectiveGeneralStudentProgramAssociation> GeneralStudentProgramAssociations = default(List<EdFiStudentCompetencyObjectiveGeneralStudentProgramAssociation>), List<EdFiStudentCompetencyObjectiveStudentSectionAssociation> StudentSectionAssociations = default(List<EdFiStudentCompetencyObjectiveStudentSectionAssociation>), string Etag = default(string))
        {
            // to ensure "Id" is required (not null)
            if (Id == null)
            {
                throw new InvalidDataException("Id is a required property for EdFiStudentCompetencyObjective and cannot be null");
            }
            else
            {
                this.Id = Id;
            }
            // to ensure "GradingPeriodReference" is required (not null)
            if (GradingPeriodReference == null)
            {
                throw new InvalidDataException("GradingPeriodReference is a required property for EdFiStudentCompetencyObjective and cannot be null");
            }
            else
            {
                this.GradingPeriodReference = GradingPeriodReference;
            }
            // to ensure "ObjectiveCompetencyObjectiveReference" is required (not null)
            if (ObjectiveCompetencyObjectiveReference == null)
            {
                throw new InvalidDataException("ObjectiveCompetencyObjectiveReference is a required property for EdFiStudentCompetencyObjective and cannot be null");
            }
            else
            {
                this.ObjectiveCompetencyObjectiveReference = ObjectiveCompetencyObjectiveReference;
            }
            // to ensure "StudentReference" is required (not null)
            if (StudentReference == null)
            {
                throw new InvalidDataException("StudentReference is a required property for EdFiStudentCompetencyObjective and cannot be null");
            }
            else
            {
                this.StudentReference = StudentReference;
            }
            // to ensure "CompetencyLevelDescriptor" is required (not null)
            if (CompetencyLevelDescriptor == null)
            {
                throw new InvalidDataException("CompetencyLevelDescriptor is a required property for EdFiStudentCompetencyObjective and cannot be null");
            }
            else
            {
                this.CompetencyLevelDescriptor = CompetencyLevelDescriptor;
            }
            this.DiagnosticStatement = DiagnosticStatement;
            this.GeneralStudentProgramAssociations = GeneralStudentProgramAssociations;
            this.StudentSectionAssociations = StudentSectionAssociations;
            this.Etag = Etag;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets GradingPeriodReference
        /// </summary>
        [DataMember(Name="gradingPeriodReference", EmitDefaultValue=false)]
        public EdFiGradingPeriodReference GradingPeriodReference { get; set; }

        /// <summary>
        /// Gets or Sets ObjectiveCompetencyObjectiveReference
        /// </summary>
        [DataMember(Name="objectiveCompetencyObjectiveReference", EmitDefaultValue=false)]
        public EdFiCompetencyObjectiveReference ObjectiveCompetencyObjectiveReference { get; set; }

        /// <summary>
        /// Gets or Sets StudentReference
        /// </summary>
        [DataMember(Name="studentReference", EmitDefaultValue=false)]
        public EdFiStudentReference StudentReference { get; set; }

        /// <summary>
        /// The CompetencyLevel assessed for the student for the referenced LearningObjective.
        /// </summary>
        /// <value>The CompetencyLevel assessed for the student for the referenced LearningObjective.</value>
        [DataMember(Name="competencyLevelDescriptor", EmitDefaultValue=false)]
        public string CompetencyLevelDescriptor { get; set; }

        /// <summary>
        /// A statement provided by the teacher that provides information in addition to the grade or assessment score.
        /// </summary>
        /// <value>A statement provided by the teacher that provides information in addition to the grade or assessment score.</value>
        [DataMember(Name="diagnosticStatement", EmitDefaultValue=false)]
        public string DiagnosticStatement { get; set; }

        /// <summary>
        /// An unordered collection of studentCompetencyObjectiveGeneralStudentProgramAssociations. Relates the Student and Program associated with the CompetencyObjective.
        /// </summary>
        /// <value>An unordered collection of studentCompetencyObjectiveGeneralStudentProgramAssociations. Relates the Student and Program associated with the CompetencyObjective.</value>
        [DataMember(Name="generalStudentProgramAssociations", EmitDefaultValue=false)]
        public List<EdFiStudentCompetencyObjectiveGeneralStudentProgramAssociation> GeneralStudentProgramAssociations { get; set; }

        /// <summary>
        /// An unordered collection of studentCompetencyObjectiveStudentSectionAssociations. Relates the Student and Section associated with the CompetencyObjective.
        /// </summary>
        /// <value>An unordered collection of studentCompetencyObjectiveStudentSectionAssociations. Relates the Student and Section associated with the CompetencyObjective.</value>
        [DataMember(Name="studentSectionAssociations", EmitDefaultValue=false)]
        public List<EdFiStudentCompetencyObjectiveStudentSectionAssociation> StudentSectionAssociations { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name="_etag", EmitDefaultValue=false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStudentCompetencyObjective {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GradingPeriodReference: ").Append(GradingPeriodReference).Append("\n");
            sb.Append("  ObjectiveCompetencyObjectiveReference: ").Append(ObjectiveCompetencyObjectiveReference).Append("\n");
            sb.Append("  StudentReference: ").Append(StudentReference).Append("\n");
            sb.Append("  CompetencyLevelDescriptor: ").Append(CompetencyLevelDescriptor).Append("\n");
            sb.Append("  DiagnosticStatement: ").Append(DiagnosticStatement).Append("\n");
            sb.Append("  GeneralStudentProgramAssociations: ").Append(GeneralStudentProgramAssociations).Append("\n");
            sb.Append("  StudentSectionAssociations: ").Append(StudentSectionAssociations).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStudentCompetencyObjective);
        }

        /// <summary>
        /// Returns true if EdFiStudentCompetencyObjective instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStudentCompetencyObjective to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStudentCompetencyObjective input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.GradingPeriodReference == input.GradingPeriodReference ||
                    (this.GradingPeriodReference != null &&
                    this.GradingPeriodReference.Equals(input.GradingPeriodReference))
                ) && 
                (
                    this.ObjectiveCompetencyObjectiveReference == input.ObjectiveCompetencyObjectiveReference ||
                    (this.ObjectiveCompetencyObjectiveReference != null &&
                    this.ObjectiveCompetencyObjectiveReference.Equals(input.ObjectiveCompetencyObjectiveReference))
                ) && 
                (
                    this.StudentReference == input.StudentReference ||
                    (this.StudentReference != null &&
                    this.StudentReference.Equals(input.StudentReference))
                ) && 
                (
                    this.CompetencyLevelDescriptor == input.CompetencyLevelDescriptor ||
                    (this.CompetencyLevelDescriptor != null &&
                    this.CompetencyLevelDescriptor.Equals(input.CompetencyLevelDescriptor))
                ) && 
                (
                    this.DiagnosticStatement == input.DiagnosticStatement ||
                    (this.DiagnosticStatement != null &&
                    this.DiagnosticStatement.Equals(input.DiagnosticStatement))
                ) && 
                (
                    this.GeneralStudentProgramAssociations == input.GeneralStudentProgramAssociations ||
                    this.GeneralStudentProgramAssociations != null &&
                    this.GeneralStudentProgramAssociations.SequenceEqual(input.GeneralStudentProgramAssociations)
                ) && 
                (
                    this.StudentSectionAssociations == input.StudentSectionAssociations ||
                    this.StudentSectionAssociations != null &&
                    this.StudentSectionAssociations.SequenceEqual(input.StudentSectionAssociations)
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.GradingPeriodReference != null)
                    hashCode = hashCode * 59 + this.GradingPeriodReference.GetHashCode();
                if (this.ObjectiveCompetencyObjectiveReference != null)
                    hashCode = hashCode * 59 + this.ObjectiveCompetencyObjectiveReference.GetHashCode();
                if (this.StudentReference != null)
                    hashCode = hashCode * 59 + this.StudentReference.GetHashCode();
                if (this.CompetencyLevelDescriptor != null)
                    hashCode = hashCode * 59 + this.CompetencyLevelDescriptor.GetHashCode();
                if (this.DiagnosticStatement != null)
                    hashCode = hashCode * 59 + this.DiagnosticStatement.GetHashCode();
                if (this.GeneralStudentProgramAssociations != null)
                    hashCode = hashCode * 59 + this.GeneralStudentProgramAssociations.GetHashCode();
                if (this.StudentSectionAssociations != null)
                    hashCode = hashCode * 59 + this.StudentSectionAssociations.GetHashCode();
                if (this.Etag != null)
                    hashCode = hashCode * 59 + this.Etag.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // CompetencyLevelDescriptor (string) maxLength
            if(this.CompetencyLevelDescriptor != null && this.CompetencyLevelDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CompetencyLevelDescriptor, length must be less than 306.", new [] { "CompetencyLevelDescriptor" });
            }

            // DiagnosticStatement (string) maxLength
            if(this.DiagnosticStatement != null && this.DiagnosticStatement.Length > 1024)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DiagnosticStatement, length must be less than 1024.", new [] { "DiagnosticStatement" });
            }

            yield break;
        }
    }

}
