/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface. The Ed-Fi ODS / API supports both transactional and bulk modes of operation.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStudentSpecialEducationProgramAssociationDisability
    /// </summary>
    [DataContract]
    public partial class EdFiStudentSpecialEducationProgramAssociationDisability :  IEquatable<EdFiStudentSpecialEducationProgramAssociationDisability>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentSpecialEducationProgramAssociationDisability" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStudentSpecialEducationProgramAssociationDisability() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentSpecialEducationProgramAssociationDisability" /> class.
        /// </summary>
        /// <param name="DisabilityDescriptor">A disability category that describes a child&#39;s impairment. (required).</param>
        /// <param name="DisabilityDeterminationSourceTypeDescriptor">The source that provided the disability determination..</param>
        /// <param name="DisabilityDiagnosis">A description of the disability diagnosis..</param>
        /// <param name="OrderOfDisability">The order by severity of student&#39;s disabilities: 1- Primary, 2 -  Secondary, 3 - Tertiary, etc..</param>
        /// <param name="Designations">An unordered collection of studentSpecialEducationProgramAssociationDisabilityDesignations. Whether the disability is IDEA, Section 504, or other disability designation..</param>
        public EdFiStudentSpecialEducationProgramAssociationDisability(string DisabilityDescriptor = default(string), string DisabilityDeterminationSourceTypeDescriptor = default(string), string DisabilityDiagnosis = default(string), int? OrderOfDisability = default(int?), List<EdFiStudentSpecialEducationProgramAssociationDisabilityDesignation> Designations = default(List<EdFiStudentSpecialEducationProgramAssociationDisabilityDesignation>))
        {
            // to ensure "DisabilityDescriptor" is required (not null)
            if (DisabilityDescriptor == null)
            {
                throw new InvalidDataException("DisabilityDescriptor is a required property for EdFiStudentSpecialEducationProgramAssociationDisability and cannot be null");
            }
            else
            {
                this.DisabilityDescriptor = DisabilityDescriptor;
            }
            this.DisabilityDeterminationSourceTypeDescriptor = DisabilityDeterminationSourceTypeDescriptor;
            this.DisabilityDiagnosis = DisabilityDiagnosis;
            this.OrderOfDisability = OrderOfDisability;
            this.Designations = Designations;
        }
        
        /// <summary>
        /// A disability category that describes a child&#39;s impairment.
        /// </summary>
        /// <value>A disability category that describes a child&#39;s impairment.</value>
        [DataMember(Name="disabilityDescriptor", EmitDefaultValue=false)]
        public string DisabilityDescriptor { get; set; }

        /// <summary>
        /// The source that provided the disability determination.
        /// </summary>
        /// <value>The source that provided the disability determination.</value>
        [DataMember(Name="disabilityDeterminationSourceTypeDescriptor", EmitDefaultValue=false)]
        public string DisabilityDeterminationSourceTypeDescriptor { get; set; }

        /// <summary>
        /// A description of the disability diagnosis.
        /// </summary>
        /// <value>A description of the disability diagnosis.</value>
        [DataMember(Name="disabilityDiagnosis", EmitDefaultValue=false)]
        public string DisabilityDiagnosis { get; set; }

        /// <summary>
        /// The order by severity of student&#39;s disabilities: 1- Primary, 2 -  Secondary, 3 - Tertiary, etc.
        /// </summary>
        /// <value>The order by severity of student&#39;s disabilities: 1- Primary, 2 -  Secondary, 3 - Tertiary, etc.</value>
        [DataMember(Name="orderOfDisability", EmitDefaultValue=false)]
        public int? OrderOfDisability { get; set; }

        /// <summary>
        /// An unordered collection of studentSpecialEducationProgramAssociationDisabilityDesignations. Whether the disability is IDEA, Section 504, or other disability designation.
        /// </summary>
        /// <value>An unordered collection of studentSpecialEducationProgramAssociationDisabilityDesignations. Whether the disability is IDEA, Section 504, or other disability designation.</value>
        [DataMember(Name="designations", EmitDefaultValue=false)]
        public List<EdFiStudentSpecialEducationProgramAssociationDisabilityDesignation> Designations { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStudentSpecialEducationProgramAssociationDisability {\n");
            sb.Append("  DisabilityDescriptor: ").Append(DisabilityDescriptor).Append("\n");
            sb.Append("  DisabilityDeterminationSourceTypeDescriptor: ").Append(DisabilityDeterminationSourceTypeDescriptor).Append("\n");
            sb.Append("  DisabilityDiagnosis: ").Append(DisabilityDiagnosis).Append("\n");
            sb.Append("  OrderOfDisability: ").Append(OrderOfDisability).Append("\n");
            sb.Append("  Designations: ").Append(Designations).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStudentSpecialEducationProgramAssociationDisability);
        }

        /// <summary>
        /// Returns true if EdFiStudentSpecialEducationProgramAssociationDisability instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStudentSpecialEducationProgramAssociationDisability to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStudentSpecialEducationProgramAssociationDisability input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DisabilityDescriptor == input.DisabilityDescriptor ||
                    (this.DisabilityDescriptor != null &&
                    this.DisabilityDescriptor.Equals(input.DisabilityDescriptor))
                ) && 
                (
                    this.DisabilityDeterminationSourceTypeDescriptor == input.DisabilityDeterminationSourceTypeDescriptor ||
                    (this.DisabilityDeterminationSourceTypeDescriptor != null &&
                    this.DisabilityDeterminationSourceTypeDescriptor.Equals(input.DisabilityDeterminationSourceTypeDescriptor))
                ) && 
                (
                    this.DisabilityDiagnosis == input.DisabilityDiagnosis ||
                    (this.DisabilityDiagnosis != null &&
                    this.DisabilityDiagnosis.Equals(input.DisabilityDiagnosis))
                ) && 
                (
                    this.OrderOfDisability == input.OrderOfDisability ||
                    (this.OrderOfDisability != null &&
                    this.OrderOfDisability.Equals(input.OrderOfDisability))
                ) && 
                (
                    this.Designations == input.Designations ||
                    this.Designations != null &&
                    this.Designations.SequenceEqual(input.Designations)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DisabilityDescriptor != null)
                    hashCode = hashCode * 59 + this.DisabilityDescriptor.GetHashCode();
                if (this.DisabilityDeterminationSourceTypeDescriptor != null)
                    hashCode = hashCode * 59 + this.DisabilityDeterminationSourceTypeDescriptor.GetHashCode();
                if (this.DisabilityDiagnosis != null)
                    hashCode = hashCode * 59 + this.DisabilityDiagnosis.GetHashCode();
                if (this.OrderOfDisability != null)
                    hashCode = hashCode * 59 + this.OrderOfDisability.GetHashCode();
                if (this.Designations != null)
                    hashCode = hashCode * 59 + this.Designations.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // DisabilityDescriptor (string) maxLength
            if(this.DisabilityDescriptor != null && this.DisabilityDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DisabilityDescriptor, length must be less than 306.", new [] { "DisabilityDescriptor" });
            }

            // DisabilityDeterminationSourceTypeDescriptor (string) maxLength
            if(this.DisabilityDeterminationSourceTypeDescriptor != null && this.DisabilityDeterminationSourceTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DisabilityDeterminationSourceTypeDescriptor, length must be less than 306.", new [] { "DisabilityDeterminationSourceTypeDescriptor" });
            }

            // DisabilityDiagnosis (string) maxLength
            if(this.DisabilityDiagnosis != null && this.DisabilityDiagnosis.Length > 80)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DisabilityDiagnosis, length must be less than 80.", new [] { "DisabilityDiagnosis" });
            }

            yield break;
        }
    }

}
