/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface. The Ed-Fi ODS / API supports both transactional and bulk modes of operation.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXFinanceChartOfAccountReportingTag
    /// </summary>
    [DataContract]
    public partial class EdFiXFinanceChartOfAccountReportingTag :  IEquatable<EdFiXFinanceChartOfAccountReportingTag>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXFinanceChartOfAccountReportingTag" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXFinanceChartOfAccountReportingTag() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXFinanceChartOfAccountReportingTag" /> class.
        /// </summary>
        /// <param name="ReportingTagDescriptor">ReportinTag Descriptor (required).</param>
        /// <param name="TagValue">TagValue.</param>
        public EdFiXFinanceChartOfAccountReportingTag(string ReportingTagDescriptor = default(string), string TagValue = default(string))
        {
            // to ensure "ReportingTagDescriptor" is required (not null)
            if (ReportingTagDescriptor == null)
            {
                throw new InvalidDataException("ReportingTagDescriptor is a required property for EdFiXFinanceChartOfAccountReportingTag and cannot be null");
            }
            else
            {
                this.ReportingTagDescriptor = ReportingTagDescriptor;
            }
            this.TagValue = TagValue;
        }
        
        /// <summary>
        /// ReportinTag Descriptor
        /// </summary>
        /// <value>ReportinTag Descriptor</value>
        [DataMember(Name="reportingTagDescriptor", EmitDefaultValue=false)]
        public string ReportingTagDescriptor { get; set; }

        /// <summary>
        /// TagValue
        /// </summary>
        /// <value>TagValue</value>
        [DataMember(Name="tagValue", EmitDefaultValue=false)]
        public string TagValue { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiXFinanceChartOfAccountReportingTag {\n");
            sb.Append("  ReportingTagDescriptor: ").Append(ReportingTagDescriptor).Append("\n");
            sb.Append("  TagValue: ").Append(TagValue).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXFinanceChartOfAccountReportingTag);
        }

        /// <summary>
        /// Returns true if EdFiXFinanceChartOfAccountReportingTag instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXFinanceChartOfAccountReportingTag to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXFinanceChartOfAccountReportingTag input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ReportingTagDescriptor == input.ReportingTagDescriptor ||
                    (this.ReportingTagDescriptor != null &&
                    this.ReportingTagDescriptor.Equals(input.ReportingTagDescriptor))
                ) && 
                (
                    this.TagValue == input.TagValue ||
                    (this.TagValue != null &&
                    this.TagValue.Equals(input.TagValue))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ReportingTagDescriptor != null)
                    hashCode = hashCode * 59 + this.ReportingTagDescriptor.GetHashCode();
                if (this.TagValue != null)
                    hashCode = hashCode * 59 + this.TagValue.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // ReportingTagDescriptor (string) maxLength
            if(this.ReportingTagDescriptor != null && this.ReportingTagDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ReportingTagDescriptor, length must be less than 306.", new [] { "ReportingTagDescriptor" });
            }

            // TagValue (string) maxLength
            if(this.TagValue != null && this.TagValue.Length > 100)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for TagValue, length must be less than 100.", new [] { "TagValue" });
            }

            yield break;
        }
    }

}
