/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface. The Ed-Fi ODS / API supports both transactional and bulk modes of operation.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea
    /// </summary>
    [DataContract]
    public partial class WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea :  IEquatable<WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea" /> class.
        /// </summary>
        /// <param name="CteProgramAreaDescriptor">WI Program areas of concentration. (required).</param>
        public WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea(string CteProgramAreaDescriptor = default(string))
        {
            // to ensure "CteProgramAreaDescriptor" is required (not null)
            if (CteProgramAreaDescriptor == null)
            {
                throw new InvalidDataException("CteProgramAreaDescriptor is a required property for WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea and cannot be null");
            }
            else
            {
                this.CteProgramAreaDescriptor = CteProgramAreaDescriptor;
            }
        }
        
        /// <summary>
        /// WI Program areas of concentration.
        /// </summary>
        /// <value>WI Program areas of concentration.</value>
        [DataMember(Name="cteProgramAreaDescriptor", EmitDefaultValue=false)]
        public string CteProgramAreaDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea {\n");
            sb.Append("  CteProgramAreaDescriptor: ").Append(CteProgramAreaDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea);
        }

        /// <summary>
        /// Returns true if WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea instances are equal
        /// </summary>
        /// <param name="input">Instance of WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WiStudentCTEProgramAssociationCTEConcentrationCteProgramArea input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CteProgramAreaDescriptor == input.CteProgramAreaDescriptor ||
                    (this.CteProgramAreaDescriptor != null &&
                    this.CteProgramAreaDescriptor.Equals(input.CteProgramAreaDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CteProgramAreaDescriptor != null)
                    hashCode = hashCode * 59 + this.CteProgramAreaDescriptor.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // CteProgramAreaDescriptor (string) maxLength
            if(this.CteProgramAreaDescriptor != null && this.CteProgramAreaDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CteProgramAreaDescriptor, length must be less than 306.", new [] { "CteProgramAreaDescriptor" });
            }

            yield break;
        }
    }

}
